Julman ensimmäinen HTPC

Jäsenten HTPC laitteistoja
Critter
Yli-ihminen
Viestit: 868
Liittynyt: 16.12.2008 19:25

Viesti Kirjoittaja Critter » 14.03.2009 0:40

Kokeiles laittaa capture card nauhoitus asetuksista:

En nyt muista mitä nää oli suomeksi:

Wait for start SEQ header: ei täppää
Open DVB card on demand: ei täppää

Toi seq header tuskin vaikuttaa, mutta toi toinen voikin vaikuttaa.

EDIT: Ainiin... Jos ei mikään auta, kokeile vielä poistaa kaikki kanavat ja hakea ne uudelleen. En muista oliko mulla toi ongelman, mutta kanavat olen kyllä hakenut uudelleen se on varma se. (muistaakseni esim. vdr merkkaa jotenkin kanavien salaujutskan ja voi olla että mytti tekee sen kanssa) ihan mutua.

Julmuri
Vanhempi harrastaja
Viestit: 79
Liittynyt: 25.02.2009 12:42

Viesti Kirjoittaja Julmuri » 14.03.2009 0:51

Ei näyttäisi olevan vaikutusta...

Toinen vaihtoehto on tietysti se, jos noissa init.d-skripteissä on jotain käpyä, nehän piti ja tehdä itse copy-pastella. Mitkä versiot sulla on käytössä? Minulla on nyt viimeisin sasc-ng ja newcs 1.64.

Critter
Yli-ihminen
Viestit: 868
Liittynyt: 16.12.2008 19:25

Viesti Kirjoittaja Critter » 14.03.2009 1:00

Julmuri kirjoitti:Ei näyttäisi olevan vaikutusta...

Toinen vaihtoehto on tietysti se, jos noissa init.d-skripteissä on jotain käpyä, nehän piti ja tehdä itse copy-pastella. Mitkä versiot sulla on käytössä? Minulla on nyt viimeisin sasc-ng ja newcs 1.64.
newcs 1.64
sasc-ng (heh... en nyt keksi miten saan sen selville........) muistaakseni joku 68

En usko että init.d scripteissä olis vika...
Mutta joku juttu on kyllä vielä jäänyt huomaamatta... Kyllä se selviää.. Ei ehkä tänään, mutta lähipäivinä..

EDIT:
Oletko kokeillut käydä tsekkailemassa newcs:n webbisivua ?
Eli jos käytät vastaavaa newcs.xml:ää kuin minä, niin selaimella

http://localhost:8080/ (localhost tietty ip:ksi jos etänä lähiverkossa/tmjs. kokeilet)

Siellä nimittäin selviää aika helposti saako newcs yhteyden plustv korttiin.

Julmuri
Vanhempi harrastaja
Viestit: 79
Liittynyt: 25.02.2009 12:42

Viesti Kirjoittaja Julmuri » 14.03.2009 1:26

Hmm... kumma. 8080-portista ei löydy mitään localhostina tai ip-osoitteella. Eli onko nyt niin että newcs:n käynnistys-skriptissä on jotain kädellään?

Critter
Yli-ihminen
Viestit: 868
Liittynyt: 16.12.2008 19:25

Viesti Kirjoittaja Critter » 14.03.2009 1:33

Julmuri kirjoitti:Hmm... kumma. 8080-portista ei löydy mitään localhostina tai ip-osoitteella. Eli onko nyt niin että newcs:n käynnistys-skriptissä on jotain kädellään?
Hmm.. ehkä kuitenkin... Missäs järjetyksessä noi käynnistyy ?

Tässä hyvä youtube ohje debian/ubuntu käynnistysjuttuihin...

http://www.youtube.com/watch?v=d39izaupvEg

Eli ensin täytyy toki newcs, sitten sasc, ja sitten vasta mythbacken käynnistyä.

Itsellä esim. S19newcs, S21sascd ja S22mythtv-backend

Julmuri
Vanhempi harrastaja
Viestit: 79
Liittynyt: 25.02.2009 12:42

Viesti Kirjoittaja Julmuri » 14.03.2009 1:39

Nyt ne käynnistyy ihan oikeassa järjestyksessä kun pudotin mythbackendiä vähän kauemmas. Nyt kuvakin näkyy heti buutin jälkeen niin kuin pitää. Järjestys on:

S19newcs, S20apache2, S20sascd, S23mythtv-backend

Critter
Yli-ihminen
Viestit: 868
Liittynyt: 16.12.2008 19:25

Viesti Kirjoittaja Critter » 14.03.2009 1:41

Minun /etc/init.d/newcs

Koodi: Valitse kaikki

# !/bin/sh
### BEGIN INIT INFO
# Provides:          newcs
# Required-Start:
# Required-Stop:
# Default-Start:     50
# Default-Stop:      S
# Short-Description: Start/Stop the NewCS server.
### END INIT INFO
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/bin/newcs.i686
NAME="newcs.i686"
DESC="Newcs Daemon"
echo -n "NewCS Script for: $NAME"

test -x $DAEMON || exit 0

set -e

# Set program options
OPTIONS="-c /etc/newcs.xml"

##start##

case "$1" in

start)
echo -n "Starting : $NAME"
start-stop-daemon --start --quiet --exec $DAEMON -- $OPTIONS
echo "...done"
;;

##stop##

stop)
echo -n "Stopping : $NAME "
killall $NAME
echo "...done"
;;

##restart##
restart|force-reload)
echo -n "restarting : $NAME "
$0 stop && $0 start
;;
*)
N=/etc/init.d/$NAME
# echo "Usage: $N {start|stop|restart}" >&2
echo "Usage: $N {start|stop|restart}" >&2
exit 1
;;
esac
/etc/init.d/sascd

Koodi: Valitse kaikki

#! /bin/bash
#
# sasc start-stop script
#

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
NAME="runsasc"
DESC="SASC-NG"
DAEMON="sasc-ng"

ENABLED=0
test -f /etc/default/sascc && . /etc/default/sascc
test "$ENABLED" != "0" || exit 0

rm -f /tmp/SASC_COMPLETE

LOOP=0
case "$1" in
  start)
         if ! ps -C sasc-ng > /dev/null 2>&1; then
         echo -e "Starting $DESC: $NAME. \n"
         runsasc &
         until [ -e /tmp/SASC_COMPLETE ] || [ $LOOP -eq $TIMEOUT ] ; do
           sleep 1
           LOOP=$((LOOP+1))
         done
         if [ $LOOP -eq $TIMEOUT ]; then
           echo -e "SASC-NG startup sequence has timed out in $TIMEOUT seconds. SASC-NG will not start. \n"
           exit 1
         fi
         echo -e "SASC-NG startup time was $LOOP second(s). \n"
         echo -e "SASC-NG startup sequence completed. \n"
         else
         echo -e "SASC-NG is already running. \n"
         fi
         ;;
  stop)
         if ps -C sasc-ng > /dev/null 2>&1; then
         echo -e "Stopping $DESC: $NAME. \n"
         sleep 3
         killall -q -TERM $NAME
         killall -q -TERM $DAEMON
         sleep 5
         rmmod dvbloopback.ko
         else
         echo -e "SASC-NG is not running. \n"
         fi
         ;;
  restart|force-reload)
         if ps -C sasc-ng > /dev/null 2>&1; then
         echo -e "Restarting $DESC: $NAME. \n"
         sleep 3
         killall -q -TERM $NAME
         killall -q -TERM $DAEMON
         sleep 5
         rmmod dvbloopback.ko
         sleep 2
         runsasc &
         until [ -e /tmp/SASC_COMPLETE ] || [ $LOOP -eq $TIMEOUT ] ; do
           sleep 1
           LOOP=$((LOOP+1))
         done
         if [ $LOOP -eq $TIMEOUT ]; then
           echo -e "SASC-NG startup sequence has timed out in $TIMEOUT seconds. SASC-NG will not start. \n"
           exit 1
         fi
         echo -e "SASC-NG startup time was $LOOP second(s). \n"
         echo -e "SASC-NG startup sequence completed. \n"
         else
         echo -e "SASC-NG is not running. \n"
         fi
         ;;
  *)
         N=/etc/init.d/$NAME
         echo "Use: $N {start|stop|restart|force-reload}" >&2
         exit 1
        ;;
esac

rm -f /tmp/SASC_COMPLETE

exit 0

Critter
Yli-ihminen
Viestit: 868
Liittynyt: 16.12.2008 19:25

Viesti Kirjoittaja Critter » 14.03.2009 1:44

Ainiin ja /usr/local/bin/runsasc

Koodi: Valitse kaikki

#!/bin/bash

# Script to automate running of SASC-NG and Drivers

# Driver directory
# DRIVERDIR="/usr/local/src/mythtv.cvs/sasc-ng"
# Path to SASC-NG binary
SASCPRG="sasc-ng"
# Path to CAM Directory
CAMDIR="/etc/camfiles/"
# Number of DVB Cards you have in your system dedicated to SASC-NG
ADAPTERS="2"
# Startup Options passed to SASC-NG.  Adjust according to your devices.
#OPTIONS="-r 0 -v 2 -o"
#OPTIONS="-j 0:3 -j 1:4 -j 2:5 --cam-budget --sid-allpid --sid-nocache --cam-dir"
OPTIONS="-j 0:2 -j 1:3 --cam-budget --sid-allpid --sid-nocache --cam-dir"
# Number of times runsasc will attempt to restart SASC-NG after a crash has occured (set to 0 for no limit)
MAXTRIES=10
# Minimum runtime required (in seconds) for SASC-NG to continue restart attempts
MINRUN=20

## End Configuration Section ##

SASCCMD="$SASCPRG $OPTIONS $CAMDIR"
KILL="/usr/bin/killall -q -TERM"

# Detect whether the DVBLooopback driver is already loaded
# and return 0 if it *is* loaded, 1 if not:
function DriverLoaded()
{
  grep -qse dvbloopback /proc/modules
}

# Load all DVBLoopback driver modules needed for your hardware:
function LoadDriver()
{
  modprobe dvbloopback num_adapters=$ADAPTERS
  sleep 5
}

# Unload all DVBLoopback driver modules loaded in LoadDriver():
function UnloadDriver()
{
  rmmod dvbloopback
}

# Load driver if it hasn't been loaded already:
if ! DriverLoaded; then
   LoadDriver
   fi

LASTRESTART=$(date +%s)
LOOPCOUNT=0
while (true) do
      if [ $LOOPCOUNT -le $MAXTRIES ] || [ $MAXTRIES -eq 0 ] ; then
        eval "screen -D -m -S sasc-ng $SASCCMD &"
        # Wait for SASC-NG to initialize then do rest
        sleep 10
        touch /tmp/SASC_COMPLETE
      else
        $KILL runsasc
      fi
      # Remember PID of SASC-NG process
      PID=$!
      # Wait for SASC-NG to end or signal to arrive
      wait $PID
      # Remember return value of SASC-NG
      RET=$?
      if test $RET -eq 0 -o $RET -eq 2; then exit; fi
      TIMEOFDEATH=$(date +%s)
      RUNTIME=$((TIMEOFDEATH - LASTRESTART))
      if [ $TIMEOFDEATH -le $(($LASTRESTART + $MINRUN)) ] ; then
        echo "`date` SASC-NG crashed in $RUNTIME seconds. Minimum required runtime for SASC-NG is $MINRUN seconds. Killing runsasc process..."
        $KILL runsasc
      fi
      echo "`date` Reloading DVBLoopback drivers"
      $KILL sasc-ng
      sleep 10
      UnloadDriver
      LoadDriver
      LASTRESTART=$(date +%s)
      LOOPCOUNT=$((LOOPCOUNT+1))
      echo "`date` Restarting SASC-NG $LOOPCOUNT time(s). Maximum retries set to $MAXTRIES"
      done

Julmuri
Vanhempi harrastaja
Viestit: 79
Liittynyt: 25.02.2009 12:42

Viesti Kirjoittaja Julmuri » 14.03.2009 2:21

Edelleen sama homma, eli 8080-portista ei vastaa mikään eikä kuvaa tule näkyviin salatulta kanavalta. Ja silti newcs näyttäisi olevan käynnissä. En enää ymmärrä mistä se voi olla kiinni. :cry:

Noh, pitänee nukkua yön yli ja ihmetellä sen jälkeen...

edit: Aamun testailua ja sama homma edelleen... asensin newcs:n kannettavaan ja testasin sillä, mutta ilman tulosta. Alkaa vähän tuntua siltä ettei tuo newcs käynnisty oikein tai jotain, nimittäin kummallakaan koneella en pääse kiinni 8080-portin kautta enkä telnetillä, vaikka periaatteessa pitäisi. Paskempi homma että kun tuo ei edes logita mitään mihinkään, niin sitä on kiva selvitellä. :(

Latailin jo newcs 1.65:nkin. Kun lataan sen käyntiin käsin komentoriviltä niin tulos on tällainen:

Koodi: Valitse kaikki

root@Myth-Pentagon:~/newcs-1.65/bin# ./newcs.x86_64 -c /etc/newcs.xml
This is NewCS 1.65 - the New CardServer by the Butter-team..
Compiled on Jan 19 2009 at 17:54:17
Reading Config file from /etc/newcs.xml
[ 12:43:52 ] [ Box detect ] Box type 1 (General Boxtype - PC compatible)
[ 12:43:52 ] [ Config ] Auto readers config enabled
[ 12:43:52 ] [ Config ] Devicetype in config must be wrong, defaulting to Phoenix..
[ 12:43:52 ] [ Config ] Devicetype in config must be wrong, defaulting to Phoenix..
[ 12:43:52 ] [ Config ] Option <cache> not present, defaulting EMM: 20, ECM: Dynamic
[ NewCS ] Process ID is: 6923
[ 12:43:52 ] [ NewCS ] Ready to GO! :)
Samat notulit tulee myös 1.64 ja 1.62 versioilla mutta edelleen 8080 ei vastaa millään tavalla.

Julmuri
Vanhempi harrastaja
Viestit: 79
Liittynyt: 25.02.2009 12:42

Viesti Kirjoittaja Julmuri » 14.03.2009 14:23

Noniin, no NYT alkaa tapahtua! :D

Eli homma kusi /etc/newcs.xml-tiedostoon. Ihmettelinkin että miksei tule enempää notulia kuin se mitä tuossa alkuun on ja lopulta hoksasin että sehän ei edes lue tuota tiedostoa kuin muutaman ensimmäisen rivin. Noh, eipä tämä mitään, vaihdoin otsikkoon <xml>:n tilalle pitkän notaation mukaisen otsikon ja johan newcs nousi ylös kuin lasarus kuolleista. Pääsen loggautumaan sisään web-liittymään jne. Foorumin softa näköjään muuttaa alkuperäisen pitkän xml-otsakkeen muotoon <xml>

Salatut kanavat eivät ihan vielä kuitenkaan näy, mutta ainakin jotain edistystä on tapahtunut... käynnistin palvelut käsin, jotta saan konsoliin jotain logia mitä tapahtuu ja kun yritän avata MTV3 MAXia niin tulee tällaista:

Koodi: Valitse kaikki

[ 13:32:54 ] [ SID ] Checking for SID 0155 for Reader 0 (Phoenix on Com1) - SO is: 0
[ 13:32:54 ] [ Conax ] Viewing status: 0000
[ 13:32:54 ] [ 0B00 ] Card ECM took: 0s 265990us
[ 13:32:54 ] [ SID ] Updating SID 0155 for Reader 0 (Phoenix on Com1) bad - SO is: 0
[ 13:32:54 ] [ SID ] Adding SID 0155 on Reader 0 (Phoenix on Com1) - SO is: 0 [Allow]
[ 13:32:54 ] [ ECM Cache ] Adding dynamic Cache entry at 2
[ 13:33:14 ] [ Newcamd:15000 ] User dummy logout
[ 13:33:14 ] [ Newcamd ] new connection from 127.0.0.1 on socket 9
[ 13:33:14 ] [ Newcamd:15000 ] Connection from 127.0.0.1
[ 13:33:14 ] [ Newcamd:15000 ] User dummy logged in, client: VDR-SC
[ 13:33:14 ] [ Newcamd:15000 ] ECM <- dummy
[ 13:33:14 ] [ SID ] Checking for SID 0137 for Reader 0 (Phoenix on Com1) - SO is: 0
[ 13:33:14 ] [ Conax ] Viewing status: 0000
[ 13:33:14 ] [ 0B00 ] Card ECM took: 0s 273149us
[ 13:33:14 ] [ SID ] Updating SID 0137 for Reader 0 (Phoenix on Com1) bad - SO is: 0
[ 13:33:14 ] [ ECM Cache ] Adding dynamic Cache entry at 2
Kaikkea muutakin tapahtuu mutta kuva ei kuitenkaan vielä virity. En tiedä johtuuko se siitä että tuo kaapelitv-yhtiön kortti ei ole ennen ollut käytössä missään...
Viimeksi muokannut Julmuri, 14.03.2009 20:20. Yhteensä muokattu 1 kertaa.

Julmuri
Vanhempi harrastaja
Viestit: 79
Liittynyt: 25.02.2009 12:42

Viesti Kirjoittaja Julmuri » 14.03.2009 15:53

Piiiiiiiiitkällisen odottelun jälkeen kuvakin alkoi näkymään. Nyt on hilpeä olo, vielä vähän aikaa sitten pelotti että puolen vuoden minimitilauksen joutuisi maksamaan täysin turhaan. Kiitos Critter, ilman apuja en olisi saanut tätä ikinä toimiman! :)

Critter
Yli-ihminen
Viestit: 868
Liittynyt: 16.12.2008 19:25

Viesti Kirjoittaja Critter » 14.03.2009 21:49

Julmuri kirjoitti:Piiiiiiiiitkällisen odottelun jälkeen kuvakin alkoi näkymään. Nyt on hilpeä olo, vielä vähän aikaa sitten pelotti että puolen vuoden minimitilauksen joutuisi maksamaan täysin turhaan. Kiitos Critter, ilman apuja en olisi saanut tätä ikinä toimiman! :)
Hienoa!!! Missä vika lopuksi oli ? Täytyikö kortti käyttää toisessa laitteessa ?

Ps. Tuntuu kyllä hienolta kun omista taistelutunneista oli lopultakin jotain hyötyä myös muille kuin itselle. Toivottvasti tästäkin threadista on taas jollekkin muulle hyötyä.

Julmuri
Vanhempi harrastaja
Viestit: 79
Liittynyt: 25.02.2009 12:42

Viesti Kirjoittaja Julmuri » 15.03.2009 1:57

Critter kirjoitti:Hienoa!!! Missä vika lopuksi oli ? Täytyikö kortti käyttää toisessa laitteessa ?

Ps. Tuntuu kyllä hienolta kun omista taistelutunneista oli lopultakin jotain hyötyä myös muille kuin itselle. Toivottvasti tästäkin threadista on taas jollekkin muulle hyötyä.
Loppujenlopuksi vika oli tuossa newcs.xml-tiedostossa, eli tämä foorumi näköjään pelkistää täydellisen xml-otsikon muotoon <xml> ja se taas aiheuttaa sen, ettei newcs lue tiedostoa oikein. En ollut hoksannut tuota ennen kuin aloin ihmettelemään, minkä takia softa antaa niille harvoille palauteriveille ihan eri arvoja mitä tiedostossa on. Hoksasin tuon ja kokeilin niin homma lähti heti toimimaan.

Sen jälkeen piti vain yrittää katsoa maksukanavaa ja kun olin käynnistänyt kaiken käsin niin sain kaikki lukemat suoraan terminaaliin. Siitä sain seurattua että jotain tapahtui. Kortin myyjä oli sanonut ettei se toimi saman tien vaan se pitäisi jättää lukijaan ja odotella kunnes jotain alkaa näkymään. Kesto vartista tuntiin... 40 minuutin jälkeen alkoi tulla ilmoituksia että oikeitakin koodeja on tullut läpi vaikkei kanava edelleenkään virittynyt, mutta kun vaihtoi hetkeksi toiselle kanavalle niin lähti toimimaan juuri niin kuin pitää. :)

Julmuri
Vanhempi harrastaja
Viestit: 79
Liittynyt: 25.02.2009 12:42

Viesti Kirjoittaja Julmuri » 24.03.2009 23:26

Taas on käytelty ja nauhoiteltu kaikenlaista... pääsääntöisesti toimii ihan hyvin. Sellaiseen ongelmaan kuitenkin törmäsin, että jostain syystä kortinlukija häviää välillä ja se aiheuttaa ikäviä katkoksia. Mahtaako noihin usb-disconnect ongelmiin olla olemassa jotain workaroundia?

Avatar
JUUeikunn
Säätäjä
Viestit: 239
Liittynyt: 24.06.2005 3:00

Viesti Kirjoittaja JUUeikunn » 25.03.2009 9:34

Auttasko siihen sama ku tuon T500:n kanssa oleva optio.

Koodi: Valitse kaikki

options usbcore autosuspend=-1
Tuolla loppui kortin toisen virittimen katoaminen.

A

Vastaa Viestiin